# OpenLP API tester.

A commandline utility to access a running OpenLP instance via it's API's and test all functionality.


It will find OpenLP on the network via ZeroConf and then using the API's build and run a service.
After each command the results are tested to make sure the WebSockets have changed. 

Tests are mastered in JSON files and run using the framework.

## Test Structure
```
process_name: test process
step1:
  max: 1
  min: 1
  name: clear_live_controller
step2:
  delay: 1
  name: clear_preview_controller
step3:
  max: 1
  min: 1
  name: new_service
step4:
  delay: 1
  name: search_and_add
  payload:
    plugin: songs
step6:
  name: load_service_sequential 
```
* process_name

   A unique name for the run
   
* step 1

   The step number, needs to be unique and in order!
   
   * delay
   
      How long to wait after a call has been made.  Default is 2 seconds for all calls.

  * max
   
      How long to wait after a call has been made.  Default is 2 seconds for all calls.

  * min
   
      How long to wait after a call has been made.  Default is 2 seconds for all calls.

  * payload
   
      How long to wait after a call has been made.  Default is 2 seconds for all calls.

  * name
   
      The step name (function name) to be called to run the step.


## Commands


## Adding API's and Internals

